OperatingSystemMXBean (Java SE 26 & JDK 26)
Description: declaration: module: java.management, package: java.lang.management, interface: OperatingSystemMXBean
Keywords: java.lang.management.OperatingSystemMXBean interface

# Interface OperatingSystemMXBean

All Superinterfaces:
  `PlatformManagedObject`

All Known Subinterfaces:
  `OperatingSystemMXBean, UnixOperatingSystemMXBean`

public interface OperatingSystemMXBean extends PlatformManagedObject
The management interface for the operating system on which the Java virtual machine is running.

A Java virtual machine has a single instance of the implementation class of this interface. This instance implementing this interface is an MXBean that can be obtained by calling the `ManagementFactory.getOperatingSystemMXBean()` method or from the `platform MBeanServer` method.

The `ObjectName` for uniquely identifying the MXBean for the operating system within an MBeanServer is:

> `java.lang:type=OperatingSystem`

It can be obtained by calling the `PlatformManagedObject.getObjectName()` method.

This interface defines several convenient methods for accessing system properties about the operating system on which the Java virtual machine is running.

Since:
  1.5
See Also:
  - `ManagementFactory.getPlatformMXBeans(Class)`
  - JMX Specification.
  - Ways to Access MXBeans

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getArch()`
  Returns the operating system architecture.
  `int`
  `getAvailableProcessors()`
  Returns the number of processors available to the Java virtual machine.
  `String`
  `getName()`
  Returns the operating system name.
  `double`
  `getSystemLoadAverage()`
  Returns the system load average for the last minute.
  `String`
  `getVersion()`
  Returns the operating system version.

  ### Methods declared in interface PlatformManagedObject

  `getObjectName`
  Modifier and Type
  Method
  Description
  `ObjectName`
  `getObjectName()`
  Returns an `ObjectName` instance representing the object name of this platform managed object.

- ## Method Details

  - ### getName

    String getName()
    Returns the operating system name. This method is equivalent to `System.getProperty("os.name")`.
    Returns:
      the operating system name.
    See Also:
      - `System.getProperty(String)`

  - ### getArch

    String getArch()
    Returns the operating system architecture. This method is equivalent to `System.getProperty("os.arch")`.
    Returns:
      the operating system architecture.
    See Also:
      - `System.getProperty(String)`

  - ### getVersion

    String getVersion()
    Returns the operating system version. This method is equivalent to `System.getProperty("os.version")`.
    Returns:
      the operating system version.
    See Also:
      - `System.getProperty(String)`

  - ### getAvailableProcessors

    int getAvailableProcessors()
    Returns the number of processors available to the Java virtual machine. This method is equivalent to the `Runtime.availableProcessors()` method.

    This value may change during a particular invocation of the virtual machine.

    Returns:
      the number of processors available to the virtual machine; never smaller than one.

  - ### getSystemLoadAverage

    double getSystemLoadAverage()
    Returns the system load average for the last minute. The system load average is the sum of the number of runnable entities queued to the available processors and the number of runnable entities running on the available processors averaged over a period of time. The way in which the load average is calculated is operating system specific but is typically a damped time-dependent average.

    If the load average is not available, a negative value is returned.

    This method is designed to provide a hint about the system load and may be queried frequently. The load average may be unavailable on some platform where it is expensive to implement this method.

    Returns:
      the system load average; or a negative value if not available.
    Since:
      1.6